/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of MD6.xs. Do not edit this file, edit MD6.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "MD6.xs"
/* 
 * This library is free software; you can redistribute it and/or
 * modify it under the same terms as Perl itself.
 * 
 *  Copyright 1998-2000 Gisle Aas.
 *  Copyright 1995-1996 Neil Winton.
 *  Copyright 1991-1992 RSA Data Security, Inc.
 *
 * This code is derived from Neil Winton's MD6-1.7 Perl module, which in
 * turn is derived from the reference implementation in RFC 1321 which
 * comes with this message:
 *
 * Copyright (C) 1991-2, RSA Data Security, Inc. Created 1991. All
 * rights reserved.
 *
 * License to copy and use this software is granted provided that it
 * is identified as the "RSA Data Security, Inc. MD6 Message-Digest
 * Algorithm" in all material mentioning or referencing this software
 * or this function.
 *
 * License is also granted to make and use derivative works provided
 * that such works are identified as "derived from the RSA Data
 * Security, Inc. MD6 Message-Digest Algorithm" in all material
 * mentioning or referencing the derived work.
 *
 * RSA Data Security, Inc. makes no representations concerning either
 * the merchantability of this software or the suitability of this
 * software for any particular purpose. It is provided "as is"
 * without express or implied warranty of any kind.
 *
 * These notices must be retained in any copies of any part of this
 * documentation and/or software.
 */

#ifdef __cplusplus
extern "C" {
#endif
#define PERL_NO_GET_CONTEXT     /* we want efficiency */
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#ifdef __cplusplus
}
#endif
#include "src/md6.h"
#ifdef G_WARN_ON
#define DOWARN (PL_dowarn & G_WARN_ON)
#else
#define DOWARN PL_dowarn
#endif
#ifndef dTHX
#define pTHX_
#define aTHX_
#endif
#ifndef INT2PTR
#define INT2PTR(any,d)	(any)(d)
#endif
static const char *
md6_error( int error ) {
  switch ( error ) {
  case MD6_SUCCESS:
    return "no error";
  case MD6_FAIL:
    return "some other problem";
  case MD6_BADHASHLEN:
    return "hashbitlen<1 or >512 bits";
  case MD6_NULLSTATE:
    return "null state passed to MD6";
  case MD6_BADKEYLEN:
    return "key length is <0 or >512 bits";
  case MD6_STATENOTINIT:
    return "state was never initialized";
  case MD6_STACKUNDERFLOW:
    return "MD6 stack underflows (shouldn't happen)";
  case MD6_STACKOVERFLOW:
    return "MD6 stack overflow (message too long)";
  case MD6_NULLDATA:
    return "null data pointer";
  case MD6_NULL_N:
    return "compress: N is null";
  case MD6_NULL_B:
    return "standard compress: null B pointer";
  case MD6_BAD_ELL:
    return "standard compress: ell not in {0,255}";
  case MD6_BAD_p:
    return "standard compress: p<0 or p>b*w";
  case MD6_NULL_K:
    return "standard compress: K is null";
  case MD6_NULL_Q:
    return "standard compress: Q is null";
  case MD6_NULL_C:
    return "standard compress: C is null";
  case MD6_BAD_L:
    return "standard compress: L <0 or > 255";
  case MD6_BAD_r:
    return "compress: r<0 or r>255";
  case MD6_OUT_OF_MEMORY:
    return "compress: storage allocation failed";
  default:
    return "unknown error";
  }
}

static void
md6_croak( int error ) {
  if ( MD6_SUCCESS != error ) {
    croak( md6_error( error ) );
  }
}

static void
MD6Init( md6_state * ctx, int d ) {
  md6_croak( md6_init( ctx, d ) );
}

static void
MD6UpdateBits( md6_state * ctx, U8 * buf, STRLEN len ) {
  md6_croak( md6_update( ctx, buf, len ) );
}

static void
MD6Update( md6_state * ctx, U8 * buf, STRLEN len ) {
  MD6UpdateBits( ctx, buf, len * 8 );
}

static void
MD6Final( U8 * digest, md6_state * ctx ) {
  md6_croak( md6_final( ctx, digest ) );
}

static md6_state *
get_md6_ctx( pTHX_ SV * sv ) {
  if ( SvROK( sv ) ) {
    sv = SvRV( sv );
    if ( SvIOK( sv ) ) {
      md6_state *ctx = INT2PTR( md6_state *, SvIV( sv ) );
      if ( ctx && ctx->sig == MD6_SIG ) {
        return ctx;
      }
    }
  }
  croak( "Not a reference to a Digest::MD6 object" );
  return ( md6_state * ) 0;     /* some compilers insist on a return value */
}

static char *
enc_hex( char *buf, const unsigned char *in, int bits ) {
  static const char hx[] = "0123456789abcdef";
  char *op = buf;
  unsigned p = 0;
  while ( bits > 0 ) {
    unsigned b = ( p & 1 ) ? ( in[p >> 1] & 0x0F ) : ( in[p >> 1] >> 4 );
    if ( bits < 4 )
      b &= ( ( 1 << bits ) - 1 ) << ( 4 - bits );
    bits -= 4;
    p++;
    *op++ = hx[b];
  }
  *op = '\0';
  return buf;
}

static char *
enc_base64( char *buf, const unsigned char *in, int bits ) {
  static const char b64[] =
      "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

  unsigned phase = 0;
  unsigned p = 0;
  char *op = buf;
  while ( bits > 0 ) {
    unsigned b = 0;
    /* get next six bits */
    switch ( phase ) {
    case 0:
      b = in[p] >> 2;
      break;
    case 1:
      b = ( ( in[p] & 0x03 ) << 4 ) | ( ( in[p + 1] & 0xF0 ) >> 4 );
      break;
    case 2:
      b = ( ( in[p + 1] & 0x0F ) << 2 ) | ( ( in[p + 2] & 0xC0 ) >> 6 );
      break;
    case 3:
      b = in[p + 2] & 0x3f;
      break;
    }
    if ( bits < 6 )
      b &= ( ( 1 << bits ) - 1 ) << ( 6 - bits );
    bits -= 6;
    if ( ++phase == 4 ) {
      phase = 0;
      p += 3;
    }
    *op++ = b64[b];
  }
  *op = '\0';
  return buf;
}

/* Formats */
#define F_BIN 0
#define F_HEX 1
#define F_B64 2

#define HASH_MAX_BITS  512
#define HASH_MAX_BYTES ( HASH_MAX_BITS / 8 )

static SV *
make_mortal_sv( pTHX_ const unsigned char *src, int bits, int type ) {
  STRLEN len;
  char result[HASH_MAX_BYTES * 2 + 1];
  char *ret;

  switch ( type ) {
  case F_BIN:
    len = ( bits + 7 ) / 8;
    ret = ( char * ) src;
    break;
  case F_HEX:
    ret = enc_hex( result, src, bits );
    len = strlen( ret );
    break;
  case F_B64:
    ret = enc_base64( result, src, bits );
    len = strlen( ret );
    break;
  default:
    croak( "Bad conversion type (%d)", type );
    break;
  }
  return sv_2mortal( newSVpv( ret, len ) );
}

/********************************************************************/

/* *INDENT-OFF* */

typedef PerlIO* InputStream;

#line 251 "MD6.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 395 "MD6.c"

XS_EUPXS(XS_Digest__MD6_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Digest__MD6_new)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "xclass, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	xclass = ST(0)
;
#line 249 "MD6.xs"
    md6_state* context;
#line 410 "MD6.c"
#line 251 "MD6.xs"
    int digest_len = (int) SvIV(get_sv("Digest::MD6::HASH_LENGTH", FALSE));
    if (!SvROK(xclass)) {
      STRLEN my_na;
      char *sclass = SvPV(xclass, my_na);
      New(55, context, 1, md6_state);
      ST(0) = sv_newmortal();
      sv_setref_pv(ST(0), sclass, (void*)context);
      SvREADONLY_on(SvRV(ST(0)));
    } else {
      context = get_md6_ctx(aTHX_ xclass);
    }
    if ( items > 1 )
      digest_len = (int) SvIV(ST(1));
    MD6Init(context, digest_len);
    XSRETURN(1);
#line 427 "MD6.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Digest__MD6_clone); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Digest__MD6_clone)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0)
;
#line 271 "MD6.xs"
    md6_state* cont = get_md6_ctx(aTHX_ self);
    const char *myname = sv_reftype(SvRV(self),TRUE);
    md6_state* context;
#line 449 "MD6.c"
#line 275 "MD6.xs"
    New(55, context, 1, md6_state);
    ST(0) = sv_newmortal();
    sv_setref_pv(ST(0), myname , (void*)context);
    SvREADONLY_on(SvRV(ST(0)));
    memcpy(context,cont,sizeof(md6_state));
    XSRETURN(1);
#line 457 "MD6.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Digest__MD6_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Digest__MD6_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "context");
    {
	md6_state*	context = get_md6_ctx(aTHX_ ST(0))
;
#line 286 "MD6.xs"
    Safefree(context);
#line 475 "MD6.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Digest__MD6_reset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Digest__MD6_reset)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0)
;
#line 292 "MD6.xs"
    md6_state* context = get_md6_ctx(aTHX_ self);
#line 494 "MD6.c"
#line 294 "MD6.xs"
    MD6Init(context, context->d);
    XSRETURN(1);  /* self */
#line 498 "MD6.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Digest__MD6_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Digest__MD6_add)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0)
;
#line 301 "MD6.xs"
    md6_state* context = get_md6_ctx(aTHX_ self);
    int i;
    unsigned char *data;
    STRLEN len;
#line 521 "MD6.c"
#line 306 "MD6.xs"
    for (i = 1; i < items; i++) {
      data = (unsigned char *)(SvPV(ST(i), len));
      MD6Update(context, data, len);
    }
    XSRETURN(1);  /* self */
#line 528 "MD6.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Digest__MD6__add_bits); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Digest__MD6__add_bits)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0)
;
#line 316 "MD6.xs"
    md6_state* context = get_md6_ctx(aTHX_ self);
    int i;
    unsigned char *data;
    STRLEN len;
    IV bits;
#line 552 "MD6.c"
#line 322 "MD6.xs"
    if (!(items & 1)) {
      croak("add_bits expects a number of data, length pairs");
    }
    for (i = 1; i < items; i += 2) {
      data = (unsigned char *)(SvPV(ST(i), len));
      bits = SvIV(ST(i+1));
      if ( bits > len * 8 ) {
        croak("not enough bits in data");
      }
      MD6UpdateBits(context, data, bits);
    }
    XSRETURN(1);  /* self */
#line 566 "MD6.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Digest__MD6_addfile); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Digest__MD6_addfile)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, fh");
    {
	SV*	self = ST(0)
;
	InputStream	fh = IoIFP(sv_2io(ST(1)))
;
#line 340 "MD6.xs"
    md6_state* context = get_md6_ctx(aTHX_ self);
    /* TODO is the correct? */
    STRLEN fill = context->bits_processed / 8;
#ifdef USE_HEAP_INSTEAD_OF_STACK
    unsigned char* buffer;
#else
    unsigned char buffer[4096];
#endif
    int  n;
#line 594 "MD6.c"
#line 350 "MD6.xs"
    if (fh) {
#ifdef USE_HEAP_INSTEAD_OF_STACK
      New(0, buffer, 4096, unsigned char);
      assert(buffer);
#endif
      if (fill) {
        /* The MD6Update() function is faster if it can work with
          * complete blocks.  This will fill up any buffered block
          * first.
          */
        STRLEN missing = 64 - fill;
        if ( (n = PerlIO_read(fh, buffer, missing)) > 0)
          MD6Update(context, buffer, n);
        else
          XSRETURN(1);  /* self */
      }

      /* Process blocks until EOF or error */
      while ( (n = PerlIO_read(fh, buffer, sizeof(buffer))) > 0) {
        MD6Update(context, buffer, n);
      }
#ifdef USE_HEAP_INSTEAD_OF_STACK
      Safefree(buffer);
#endif
      if (PerlIO_error(fh)) {
        croak("Reading from filehandle failed");
      }
    }
    else {
        croak("No filehandle passed");
    }
    XSRETURN(1);  /* self */
#line 628 "MD6.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Digest__MD6_digest); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Digest__MD6_digest)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "context");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	md6_state*	context = get_md6_ctx(aTHX_ ST(0))
;
#line 391 "MD6.xs"
    unsigned char digeststr[HASH_MAX_BYTES];
#line 648 "MD6.c"
#line 393 "MD6.xs"
    MD6Final(digeststr, context);
    MD6Init(context, context->d);  /* In case it is reused */
    ST(0) = make_mortal_sv(aTHX_ digeststr,  context->d, ix);
    XSRETURN(1);
#line 654 "MD6.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Digest__MD6_md6); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Digest__MD6_md6)
{
    dVAR; dXSARGS;
    dXSI32;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 405 "MD6.xs"
    md6_state ctx;
    int i;
    unsigned char *data;
    STRLEN len;
    unsigned char digeststr[HASH_MAX_BYTES];
#line 677 "MD6.c"
#line 411 "MD6.xs"
    int digest_len = (int) SvIV(get_sv("Digest::MD6::HASH_LENGTH", FALSE));
    MD6Init(&ctx, digest_len);

    if (DOWARN) {
      char *msg = 0;
      if (items == 1) {
        if (SvROK(ST(0))) {
          SV* sv = SvRV(ST(0));
          if (SvOBJECT(sv) && strEQ(HvNAME(SvSTASH(sv)), "Digest::MD6"))
            msg = "probably called as method";
          else
            msg = "called with reference argument";
        }
      }
      else if (items > 1) {
        data = (unsigned char *)SvPV(ST(0), len);
        if (len == 11 && memEQ("Digest::MD6", data, 11)) {
          msg = "probably called as class method";
        }
        else if (SvROK(ST(0))) {
          SV* sv = SvRV(ST(0));
          if (SvOBJECT(sv) && strEQ(HvNAME(SvSTASH(sv)), "Digest::MD6"))
            msg = "probably called as method";
        }
      }
      if (msg) {
        const char *f = 
            (ix == F_BIN) ? "md6" 
          : (ix == F_HEX) ? "md6_hex" 
          :                 "md6_base64";
        warn("&Digest::MD6::%s function %s", f, msg);
      }
    }

    for (i = 0; i < items; i++) {
      data = (unsigned char *)(SvPV(ST(i), len));
      MD6Update(&ctx, data, len);
    }
    MD6Final(digeststr, &ctx);
    ST(0) = make_mortal_sv(aTHX_ digeststr, ctx.d, ix);
    XSRETURN(1);
#line 720 "MD6.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Digest__MD6); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Digest__MD6)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

    {
        CV * cv;

        newXS_deffile("Digest::MD6::new", XS_Digest__MD6_new);
        newXS_deffile("Digest::MD6::clone", XS_Digest__MD6_clone);
        newXS_deffile("Digest::MD6::DESTROY", XS_Digest__MD6_DESTROY);
        newXS_deffile("Digest::MD6::reset", XS_Digest__MD6_reset);
        newXS_deffile("Digest::MD6::add", XS_Digest__MD6_add);
        newXS_deffile("Digest::MD6::_add_bits", XS_Digest__MD6__add_bits);
        newXS_deffile("Digest::MD6::addfile", XS_Digest__MD6_addfile);
        cv = newXS_deffile("Digest::MD6::b64digest", XS_Digest__MD6_digest);
        XSANY.any_i32 = F_B64;
        cv = newXS_deffile("Digest::MD6::digest", XS_Digest__MD6_digest);
        XSANY.any_i32 = F_BIN;
        cv = newXS_deffile("Digest::MD6::hexdigest", XS_Digest__MD6_digest);
        XSANY.any_i32 = F_HEX;
        cv = newXS_deffile("Digest::MD6::md6", XS_Digest__MD6_md6);
        XSANY.any_i32 = F_BIN;
        cv = newXS_deffile("Digest::MD6::md6_base64", XS_Digest__MD6_md6);
        XSANY.any_i32 = F_B64;
        cv = newXS_deffile("Digest::MD6::md6_hex", XS_Digest__MD6_md6);
        XSANY.any_i32 = F_HEX;
    }
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

